﻿using System;
using System.Collections.Generic;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace CalendarSampleDemo
{
	public partial class CalendarSampleDemoPage : ContentPage
	{
		private bool isManuallyUpdated = false;
		private DateTime startDate;
		private DateTime endDate;
		public CalendarSampleDemoPage(DateTime start,DateTime end)
		{
			InitializeComponent();
			startDate = start;
			endDate = end;
			calendar.MoveToDate = end;
			calendar.SelectionChanged += Calendar_SelectionChanged;
			if (GetSelectedDates(start, end).Count == 2)
				isManuallyUpdated = true;
			calendar.SelectedDates = GetSelectedDates(start, end);
			calendar.OnCalendarTapped+= Calendar_OnCalendarTapped;
		}

		private List<DateTime> GetSelectedDates(DateTime start, DateTime end)
		{
			List<DateTime> tempSelectedDates = new List<DateTime>();
			for (DateTime dt = start.Date; dt <= end.Date; dt = dt.AddDays(1))
			{
				tempSelectedDates.Add(dt);
			}
			return tempSelectedDates;
		}

		private List<DateTime> ValidateDates(DateTime newSelectedDate)
		{
			List<DateTime> tempSelectedDates = new List<DateTime>();
			if ((!(newSelectedDate.Date <= endDate.Date && newSelectedDate.Date >= startDate.Date)))
			{

				tempSelectedDates.Add(newSelectedDate);
			}
			return tempSelectedDates;
		}
		bool isAlreadyCalled;
		void Calendar_OnCalendarTapped(object sender, Syncfusion.SfCalendar.XForms.CalendarTappedEventArgs args)
		{
			isAlreadyCalled = false;
		}

		void  Calendar_SelectionChanged(object sender, Syncfusion.SfCalendar.XForms.SelectionChangedEventArgs args)
		{
			if (!isAlreadyCalled)
			{
				isAlreadyCalled = true;
				if (args.DateAdded.Count == 2)
				{
					if (!(args.DateAdded[0].Date < args.DateAdded[1].Date))
					{
						List<DateTime> sDates = new List<DateTime>();
						sDates.Add(args.DateAdded[1].Date);
						calendar.SelectedDates = sDates;
					}
					else
					{
						if (!isManuallyUpdated)
						{
							calendar.SelectedDates = GetSelectedDates(args.DateAdded[0], args.DateAdded[1]);
						
						}
						else
							isManuallyUpdated = false;
					}
				}
				else if (args.DateAdded.Count > 2)
				{

					if (ValidateDates(args.DateAdded[args.DateAdded.Count - 1]).Count > 0)
					{
						calendar.SelectedDates = new List<DateTime>();
						calendar.SelectedDates = ValidateDates(args.DateAdded[args.DateAdded.Count - 1]);
				}
				}
			}
		
		}

	}
}


